; This is the C run-time start-off routine.  It's job is to take the
; arguments as put on the stack by EXEC, and to parse them and set them up the
; way _main expects them.

		GET	$.arm.aslib.register

		AREA	|C$$code|, CODE, READONLY

		EXPORT	|__start|
		EXPORT	|__main|
		EXPORT	begtext
		IMPORT	main
		IMPORT	exit

begtext
crtso
|__main|
|__start|
		ENTRY

		AND	R0, LK, #&03FFFFFC
		SUB	R0, R0, #&10	; R0 = start of program
		LDR	R1, p__progstart
		STR	R0, [R1, #0]	; save start address of program
		LDR	R1, [R0, #&14]	; get text segment size
		LDR	R2, [R0, #&18]	; data segment size
		ADD	R1, R1, R2
		LDR	R2, [R0, #&20]	; bss segment size
		ADD	R1, R1, R2
		ADD	R1, R1, R0	; end address of program
		LDR	R2, pbrksize
		STR	R1, [R2, #0]

		STR	A1, [A2, #0]	; save it
		LDR	A1, [SP, #0]	; fetch argc
		ADD	A2, SP, #4	; generate argv
		MOV	A3, A2
loop		LDR	A4, [A3, #0]	; search end of argv
		CMP	A4, #0
		ADDNE	A3, A3, #4
		BNE	loop
		ADD	A3, A3, #4	; plus 4 gives start of environment
		LDR	A4, penviron
		STR	A3, [A4, #0]	; save start in environment variable
		BL	main
		BL	exit

loop2		B	loop2		; shouldn't be executed
penviron	DCD	environ
pbrksize	DCD	brksize
p__progstart	DCD	|__progstart|


		AREA	|C$$data|

		EXPORT	begdata
		EXPORT	environ
		EXPORT	brksize
		EXPORT	|__progstart|

begdata
environ		DCD	0
brksize		DCD	0
|__progstart|	DCD	0


		AREA	|C$$bss|

		EXPORT	begbss
begbss

		END
